var assert = require('assert');
var pgn = require('../../lib/main');

assert.deepEqual(pgn.parse('e4+='), {movetext:{moves:[{san:"e4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('e4=+'), {movetext:{moves:[{san:"e4",sac:['=+']}]}});
assert.deepEqual(pgn.parse('e4='), {movetext:{moves:[{san:"e4",sac:['=']}]}});
assert.deepEqual(pgn.parse('e4+/-'), {movetext:{moves:[{san:"e4",sac:['+/-']}]}});
assert.deepEqual(pgn.parse('e4-/+'), {movetext:{moves:[{san:"e4",sac:['-/+']}]}});
assert.deepEqual(pgn.parse('e4+-'), {movetext:{moves:[{san:"e4",sac:['+-']}]}});
assert.deepEqual(pgn.parse('e4-+'), {movetext:{moves:[{san:"e4",sac:['-+']}]}});
assert.deepEqual(pgn.parse('e4&'), {movetext:{moves:[{san:"e4",sac:['&']}]}});
assert.deepEqual(pgn.parse('e4+--'), {movetext:{moves:[{san:"e4",sac:['+--']}]}});
assert.deepEqual(pgn.parse('e4--+'), {movetext:{moves:[{san:"e4",sac:['--+']}]}});
assert.deepEqual(pgn.parse('e4zz'), {movetext:{moves:[{san:"e4",sac:['zz']}]}});
assert.deepEqual(pgn.parse('e4@'), {movetext:{moves:[{san:"e4",sac:['@']}]}});
assert.deepEqual(pgn.parse('e4^'), {movetext:{moves:[{san:"e4",sac:['^']}]}});
assert.deepEqual(pgn.parse('e4->'), {movetext:{moves:[{san:"e4",sac:['->']}]}});
assert.deepEqual(pgn.parse('e4=/&'), {movetext:{moves:[{san:"e4",sac:['=/&']}]}});
assert.deepEqual(pgn.parse('e4>>'), {movetext:{moves:[{san:"e4",sac:['>>']}]}});
assert.deepEqual(pgn.parse('e4<<'), {movetext:{moves:[{san:"e4",sac:['<<']}]}});
assert.deepEqual(pgn.parse('e4//'), {movetext:{moves:[{san:"e4",sac:['//']}]}});
assert.deepEqual(pgn.parse('e4||'), {movetext:{moves:[{san:"e4",sac:['||']}]}});
assert.deepEqual(pgn.parse('e4->/<-'), {movetext:{moves:[{san:"e4",sac:['->/<-']}]}});
assert.deepEqual(pgn.parse('e4O'), {movetext:{moves:[{san:"e4",sac:['O']}]}});

assert.deepEqual(pgn.parse('e4+ +='), {movetext:{moves:[{san:"e4+",sac:['+=']}]}});
assert.deepEqual(pgn.parse('e4+ =+'), {movetext:{moves:[{san:"e4+",sac:['=+']}]}});
assert.deepEqual(pgn.parse('e4+ ='), {movetext:{moves:[{san:"e4+",sac:['=']}]}});
assert.deepEqual(pgn.parse('e4+ +/-'), {movetext:{moves:[{san:"e4+",sac:['+/-']}]}});
assert.deepEqual(pgn.parse('e4+ -/+'), {movetext:{moves:[{san:"e4+",sac:['-/+']}]}});
assert.deepEqual(pgn.parse('e4+ +-'), {movetext:{moves:[{san:"e4+",sac:['+-']}]}});
assert.deepEqual(pgn.parse('e4+ -+'), {movetext:{moves:[{san:"e4+",sac:['-+']}]}});
assert.deepEqual(pgn.parse('e4+ &'), {movetext:{moves:[{san:"e4+",sac:['&']}]}});
assert.deepEqual(pgn.parse('e4+ +--'), {movetext:{moves:[{san:"e4+",sac:['+--']}]}});
assert.deepEqual(pgn.parse('e4+ --+'), {movetext:{moves:[{san:"e4+",sac:['--+']}]}});
assert.deepEqual(pgn.parse('e4+ zz'), {movetext:{moves:[{san:"e4+",sac:['zz']}]}});
assert.deepEqual(pgn.parse('e4+ @'), {movetext:{moves:[{san:"e4+",sac:['@']}]}});
assert.deepEqual(pgn.parse('e4+ ^'), {movetext:{moves:[{san:"e4+",sac:['^']}]}});
assert.deepEqual(pgn.parse('e4+ ->'), {movetext:{moves:[{san:"e4+",sac:['->']}]}});
assert.deepEqual(pgn.parse('e4+ =/&'), {movetext:{moves:[{san:"e4+",sac:['=/&']}]}});
assert.deepEqual(pgn.parse('e4+ >>'), {movetext:{moves:[{san:"e4+",sac:['>>']}]}});
assert.deepEqual(pgn.parse('e4+ <<'), {movetext:{moves:[{san:"e4+",sac:['<<']}]}});
assert.deepEqual(pgn.parse('e4+ //'), {movetext:{moves:[{san:"e4+",sac:['//']}]}});
assert.deepEqual(pgn.parse('e4+ ||'), {movetext:{moves:[{san:"e4+",sac:['||']}]}});
assert.deepEqual(pgn.parse('e4+ ->/<-'), {movetext:{moves:[{san:"e4+",sac:['->/<-']}]}});
assert.deepEqual(pgn.parse('e4+ O'), {movetext:{moves:[{san:"e4+",sac:['O']}]}});

assert.deepEqual(pgn.parse('e2-e4 +='), {movetext:{moves:[{san:"e2-e4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('Pe2-e4 +='), {movetext:{moves:[{san:"Pe2-e4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('dxe4 +='), {movetext:{moves:[{san:"dxe4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('Rexe4 +='), {movetext:{moves:[{san:"Rexe4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('Re1xe4 +='), {movetext:{moves:[{san:"Re1xe4",sac:['+=']}]}});
assert.deepEqual(pgn.parse('e8=Q +='), {movetext:{moves:[{san:"e8=Q",sac:['+=']}]}});
assert.deepEqual(pgn.parse('e8=Q+ +='), {movetext:{moves:[{san:"e8=Q+",sac:['+=']}]}});

assert.deepEqual(pgn.parse('e4# +='), {movetext:{moves:[{san:"e4#",sac:['+=']}]}});
assert.deepEqual(pgn.parse('e4# =+'), {movetext:{moves:[{san:"e4#",sac:['=+']}]}});
assert.deepEqual(pgn.parse('e4# ='), {movetext:{moves:[{san:"e4#",sac:['=']}]}});
assert.deepEqual(pgn.parse('e4# +/-'), {movetext:{moves:[{san:"e4#",sac:['+/-']}]}});
assert.deepEqual(pgn.parse('e4# -/+'), {movetext:{moves:[{san:"e4#",sac:['-/+']}]}});
assert.deepEqual(pgn.parse('e4# +-'), {movetext:{moves:[{san:"e4#",sac:['+-']}]}});
assert.deepEqual(pgn.parse('e4# -+'), {movetext:{moves:[{san:"e4#",sac:['-+']}]}});
assert.deepEqual(pgn.parse('e4# &'), {movetext:{moves:[{san:"e4#",sac:['&']}]}});
assert.deepEqual(pgn.parse('e4# +--'), {movetext:{moves:[{san:"e4#",sac:['+--']}]}});
assert.deepEqual(pgn.parse('e4# --+'), {movetext:{moves:[{san:"e4#",sac:['--+']}]}});
assert.deepEqual(pgn.parse('e4# zz'), {movetext:{moves:[{san:"e4#",sac:['zz']}]}});
assert.deepEqual(pgn.parse('e4# @'), {movetext:{moves:[{san:"e4#",sac:['@']}]}});
assert.deepEqual(pgn.parse('e4# ^'), {movetext:{moves:[{san:"e4#",sac:['^']}]}});
assert.deepEqual(pgn.parse('e4# ->'), {movetext:{moves:[{san:"e4#",sac:['->']}]}});
assert.deepEqual(pgn.parse('e4# =/&'), {movetext:{moves:[{san:"e4#",sac:['=/&']}]}});
assert.deepEqual(pgn.parse('e4# >>'), {movetext:{moves:[{san:"e4#",sac:['>>']}]}});
assert.deepEqual(pgn.parse('e4# <<'), {movetext:{moves:[{san:"e4#",sac:['<<']}]}});
assert.deepEqual(pgn.parse('e4# //'), {movetext:{moves:[{san:"e4#",sac:['//']}]}});
assert.deepEqual(pgn.parse('e4# ||'), {movetext:{moves:[{san:"e4#",sac:['||']}]}});
assert.deepEqual(pgn.parse('e4# ->/<-'), {movetext:{moves:[{san:"e4#",sac:['->/<-']}]}});
assert.deepEqual(pgn.parse('e4# O'), {movetext:{moves:[{san:"e4#",sac:['O']}]}});

assert.deepEqual(pgn.parse('e4 += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+ += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4# += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4#",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4!! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4!!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4?? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4??",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4!? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4!?",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4?! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4?!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4?",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+!! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+!!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+?? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+??",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+!? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+!?",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+?! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+?!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+! += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+!",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
assert.deepEqual(pgn.parse('e4+? += =+ = +/- -/+ +- -+ & +-- --+ zz @ ^ -> =/& >> << // || ->/<- O'), {movetext:{moves:[{san:"e4+?",sac:['+=','=+','=','+/-','-/+','+-','-+','&','+--','--+','zz','@','^','->','=/&','>>','<<','//','||','->/<-','O']}]}});
